/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FPGT                                                     */
/* Tabela : FORMPGTO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FPGT
BEFORE INSERT OR UPDATE OR DELETE
ON FORMPGTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFPGT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFORMPGTO,0)   <> NVL(:NEW.CDFORMPGTO,0))   OR
         (NVL(:OLD.NMFORMPGTO,0)   <> NVL(:NEW.NMFORMPGTO,0))   OR
         (NVL(:OLD.IDTIPODTPGTO,0) <> NVL(:NEW.IDTIPODTPGTO,0)) OR
         (NVL(:OLD.IDTPPERIODO,0)  <> NVL(:NEW.IDTPPERIODO,0)) THEN
         :NEW.DTULTATUFPGT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FORMPGTO', '', 'CDFORMPGTO='||:OLD.CDFORMPGTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FORMPGTO MODIFY DTULTATUFPGT DEFAULT SYSDATE
/
