/* Tabela MOVDEBBANC: Movimento de Dbito Bancrio */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MOVDEBBANC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Movimento de Dbito Bancrio,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_MOVDEBI
AFTER DELETE OR INSERT OR UPDATE
ON MOVDEBBANC FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
BEGIN
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO   := '3';
      V_DESC   := 'Dt Debi. '   || TO_CHAR(:OLD.DTMOVIDEBI, 'DD/MM/YYYY') ||
                  ' Valor '     || TO_CHAR(:OLD.VRMOVIDEBI)               ||
                  ' Tipo Debi ' || :OLD.CDTPDEBIBANC                      ||
                  ' ContCC '    || :OLD.CDREDUCONT                        ||
                  ' Empresa '   || :OLD.CDEMPRESA                         ||
                  ' Classf '    || :OLD.CDCLASSFINA                       ||
                  ' FiliFx '    || :OLD.CDFILIAL                          ||
                  ' DtFx'       || TO_CHAR(:OLD.DTMOVFLUXO, 'DD/MM/YYYY') ||
                  ' IdTpFx '    || :OLD.IDMOVFLUXO                        ||
                  ' NrMovBanc ' || :OLD.NRMOVBANC                         ||
                  ' FiliDebi '  || :OLD.CDFILILANDEB;


      V_ITPESQ       := :OLD.CDREDUCONT||:OLD.NRMOVIDEBI|| '/' ||:OLD.NRMOVBANC;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDREDUCONT||:OLD.NRMOVIDEBI|| '/' ||:OLD.NRMOVBANC;
         V_CDFILLOGOPER := :OLD.CDFILIAL;

         IF (:NEW.DTMOVIDEBI   <> :OLD.DTMOVIDEBI)    OR
            (:NEW.VRMOVIDEBI   <> :OLD.VRMOVIDEBI)    OR
            (:NEW.CDTPDEBIBANC <> :OLD.CDTPDEBIBANC)  OR
            (:NEW.CDREDUCONT   <> :OLD.CDREDUCONT)    OR
            (:NEW.CDFILILANDEB <> :OLD.CDFILILANDEB)  OR
            (:NEW.CDEMPRESA    <> :OLD.CDEMPRESA)     THEN
            V_TIPO   := '2';
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDREDUCONT||:NEW.NRMOVIDEBI|| '/' ||:NEW.NRMOVBANC;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC   := 'Dt Debi. '   || TO_CHAR(:NEW.DTMOVIDEBI, 'DD/MM/YYYY') ||
                  ' Valor '     || TO_CHAR(:NEW.VRMOVIDEBI)               ||
                  ' Tipo Debi ' || :NEW.CDTPDEBIBANC                      ||
                  ' ContCC '    || :NEW.CDREDUCONT                        ||
                  ' Empresa '   || :NEW.CDEMPRESA                         ||
                  ' Classf '    || :NEW.CDCLASSFINA                       ||
                  ' FiliFx '    || :NEW.CDFILIAL                          ||
                  ' DtFx'       || TO_CHAR(:NEW.DTMOVFLUXO, 'DD/MM/YYYY') ||
                  ' IdTpFx '    || :NEW.IDMOVFLUXO                        ||
                  ' NrMovBanc ' || :NEW.NRMOVBANC                         ||
                  ' FiliDebi '  || :NEW.CDFILILANDEB;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('MOVDEBBANC', V_DTOPER, V_USUARIO,
                V_TIPO, V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_MOVDEBI','5.20.000'); END;
/

